import { CollectionReference } from "@firebase/firestore-types";
import { RAFirebaseOptions } from "../RAFirebaseOptions";
import { IFirebaseWrapper } from "./firebase/IFirebaseWrapper";
import { messageTypes } from "../../misc";
export declare type DocumentData = {
    [field: string]: any;
};
export interface IResource {
    path: string;
    pathAbsolute: string;
    collection: CollectionReference;
    list: Array<{} & {
        deleted?: boolean;
        [attr: string]: any;
    }>;
    resolvedReferences?: Array<{
        [attr: string]: any;
    }>;
}
export declare class ResourceManager {
    private fireWrapper;
    private options;
    private resources;
    private db;
    constructor(fireWrapper: IFirebaseWrapper, options: RAFirebaseOptions);
    TryGetResource(resourceName: string, refresh?: "REFRESH", collectionQuery?: messageTypes.CollectionQueryType): Promise<IResource>;
    GetResource(relativePath: string): IResource;
    TryGetResourcePromise(relativePath: string, collectionQuery?: messageTypes.CollectionQueryType): Promise<IResource>;
    RefreshResource(relativePath: string, collectionQuery: messageTypes.CollectionQueryType | undefined): Promise<void>;
    GetSingleDoc(relativePath: string, docId: string): Promise<any>;
    private initPath;
    private parseFireStoreDocument;
    getUserIdentifier(): Promise<string>;
    private getCurrentUserEmail;
    private getCurrentUserId;
    private removeResource;
    private applyQuery;
}
